{Unit to encode and decode in fast mode 8 byte blocks by the DES ECB method.
Assembler version 2.2 (12 June 2005)
Copyright (C) 2002-2005 Franco Milani
email: nadir@solaris.polarhome.com
       astlab@inwind.it
This software is part of the des package available at:
http://www.polarhome.com/~franco
http://www.polarhome.com:723/~nadir/software
http://spazioinwind.libero.it/frm/software
-----------------------------------------------------------------------------
This software is released in the hope that it will be useful, but on
an as-is basis. No warranty of any kind is offered, either expressed
or implied, including, without limitation, the implied warranties of
merchantability and fitness for a particular purpose.
You can use and modify this unit for personal purposes. You can also
redistribute it, but only in the original unmodified form and keeping
intact any part, included the above copyright notice. Possible changes
in the distributed versions will be made only by the author according
to hints, requests or bug reports.
You may distribute software items that link this unit or part of it
provided that you inform the recipients that this unit is employed,
by mentioning in the software or in its documentation who the author
of this unit is and the web location where the unit may be found.
-----------------------------------------------------------------------------}
{$packrecords 1}
{$asmmode intel}
{$ifndef ver1_0}{$calling oldfpccall}{$endif}
UNIT desecb;

INTERFACE

TYPE

block = array [1..8] of byte;

procedure DES_init (key: block; fcode: boolean);
procedure DES_code (inpb: block; var outb: block);

IMPLEMENTATION

CONST

SA1 : array [0..63] of byte =
     (1,0,1,0,0,1,1,1,0,1,0,1,0,1,0,0,0,1,0,0,1,0,1,0,1,0,1,1,1,0,0,1,
      0,0,1,1,1,0,0,1,1,1,1,0,0,1,0,0,1,1,1,0,0,1,0,0,0,1,0,1,1,0,0,1);
SA2 : array [0..63] of byte =
     (1,0,1,1,0,1,0,0,1,0,0,1,1,0,0,1,0,1,0,0,1,0,1,1,1,0,0,1,0,1,1,0,
      0,1,0,1,1,0,1,0,0,1,1,0,1,0,0,1,1,1,1,0,0,1,0,0,1,0,0,1,0,0,1,1);
SA3 : array [0..63] of byte =
     (1,0,1,1,0,0,1,0,0,1,1,0,1,0,0,1,1,0,0,1,0,0,0,1,0,1,0,1,1,1,1,0,
      1,0,0,1,1,1,0,0,1,0,0,1,0,1,1,0,0,1,1,0,0,1,1,0,0,1,1,0,1,0,0,1);
SA4 : array [0..63] of byte =
     (0,1,1,0,0,0,1,1,0,0,1,0,1,1,0,1,1,1,1,0,0,1,0,0,0,0,0,1,0,1,1,1,
      1,0,1,0,1,1,0,1,1,0,0,1,0,0,1,0,0,1,0,0,1,0,1,1,1,0,0,1,1,0,0,1);
SA5 : array [0..63] of byte =
     (0,1,0,0,0,1,1,0,1,0,0,1,1,0,1,1,1,1,0,1,0,0,1,0,0,0,1,1,0,1,1,0,
      0,0,0,1,1,1,0,1,1,1,1,0,0,0,0,1,1,1,1,0,0,1,0,1,0,1,0,1,1,0,0,0);
SA6 : array [0..63] of byte =
     (1,0,1,1,1,0,0,1,0,1,0,0,1,0,0,1,1,1,0,0,0,1,1,0,0,0,1,1,0,1,0,1,
      1,1,1,0,0,1,1,0,0,0,0,1,0,1,1,0,0,0,0,1,1,0,1,1,1,1,0,0,0,0,1,1);
SA7 : array [0..63] of byte =
     (0,1,0,1,1,0,1,1,0,1,1,0,0,1,0,0,1,0,1,0,0,1,0,1,1,0,0,1,0,1,1,0,
      0,0,1,1,1,0,0,1,1,1,0,1,0,0,1,0,0,1,1,1,0,0,1,0,1,0,0,1,1,0,0,1);
SA8 : array [0..63] of byte =
     (1,0,1,0,0,1,1,0,1,1,0,1,0,0,1,0,0,1,1,1,1,0,0,0,1,0,0,1,0,1,1,0,
      0,1,0,0,1,1,1,0,0,0,1,1,1,0,0,1,0,0,1,0,0,1,1,1,1,1,1,0,0,0,0,1);
SB1 : array [0..63] of byte =
     (1,1,1,0,0,1,0,0,0,0,1,1,1,0,0,1,0,1,1,1,1,0,1,0,0,1,1,0,0,1,0,0,
      1,0,1,0,1,1,0,0,1,1,0,1,0,0,1,0,1,1,0,0,1,0,0,1,1,0,0,1,0,0,1,1);
SB2 : array [0..63] of byte =
     (1,0,0,1,1,0,0,1,0,1,0,1,1,0,1,0,0,1,1,1,1,0,0,1,1,0,0,0,1,0,0,1,
      0,1,1,0,0,1,1,0,1,0,1,1,0,0,0,1,1,0,0,0,0,1,1,0,0,1,1,1,0,1,1,0);
SB3 : array [0..63] of byte =
     (0,0,0,1,1,0,1,1,0,1,1,1,0,1,0,0,1,1,0,0,0,1,1,0,0,0,1,1,1,0,1,0,
      1,1,1,0,0,1,0,0,0,0,0,1,1,0,1,1,0,0,1,0,1,0,0,1,1,1,1,0,0,1,0,1);
SB4 : array [0..63] of byte =
     (1,1,1,0,0,1,0,0,0,0,0,1,0,1,1,1,1,0,0,1,1,1,0,0,1,1,0,1,0,0,1,0,
      0,1,0,0,1,0,1,1,1,0,0,1,1,0,0,1,0,1,0,1,0,0,1,0,0,1,1,0,1,1,0,1);
SB5 : array [0..63] of byte =
     (0,1,1,0,1,0,0,1,0,1,0,1,1,0,1,0,1,0,0,1,1,1,1,0,1,0,1,0,0,0,0,1,
      1,0,0,0,0,1,1,0,1,0,1,1,1,0,0,1,0,0,1,1,0,1,0,1,1,1,0,0,0,1,1,0);
SB6 : array [0..63] of byte =
     (1,0,0,1,0,0,1,0,0,1,0,1,1,1,1,0,0,1,1,0,1,1,0,1,1,0,1,1,0,0,0,0,
      0,1,1,1,0,0,1,0,1,0,1,0,0,1,0,1,1,0,0,1,0,1,1,0,0,1,0,1,1,0,0,1);
SB7 : array [0..63] of byte =
     (1,0,0,1,1,0,0,1,0,1,0,1,1,0,1,0,1,0,0,1,1,0,0,0,1,0,1,1,0,1,0,1,
      0,1,0,1,1,0,1,1,0,1,1,0,0,1,0,0,1,0,1,0,0,1,0,1,0,1,0,1,1,0,0,1);
SB8 : array [0..63] of byte =
     (1,0,0,1,1,1,0,0,0,0,0,1,1,0,1,1,0,1,1,0,0,0,1,1,1,1,1,0,0,1,0,0,
      1,0,1,0,0,1,1,0,0,1,0,1,1,0,1,0,0,0,1,1,1,0,0,1,1,1,0,0,0,1,1,0);
SC1 : array [0..63] of byte =
     (1,0,0,0,1,1,1,0,1,1,1,0,0,0,0,1,0,1,1,0,1,1,0,0,1,1,0,1,0,0,1,0,
      0,0,1,0,0,1,1,1,1,0,0,1,1,1,0,0,1,0,0,1,0,0,0,1,0,1,1,1,1,0,1,0);
SC2 : array [0..63] of byte =
     (1,0,0,1,1,1,1,0,0,1,1,0,0,0,0,1,1,0,0,1,1,1,0,1,0,0,0,1,1,0,1,0,
      0,1,1,1,1,0,0,0,0,0,0,1,0,1,1,1,0,0,1,0,1,1,0,1,1,1,1,0,0,0,1,0);
SC3 : array [0..63] of byte =
     (1,0,0,1,1,1,1,0,0,0,0,1,1,0,1,0,0,1,0,0,1,0,1,1,1,0,0,1,0,1,1,0,
      0,1,0,0,0,1,1,0,1,0,1,0,0,1,1,1,0,1,0,0,1,0,0,1,0,1,1,1,1,0,1,0);
SC4 : array [0..63] of byte =
     (1,0,1,1,0,1,0,1,0,1,0,0,1,0,0,1,0,0,1,0,1,1,0,1,0,1,1,0,0,1,1,0,
      1,1,0,0,0,1,1,0,1,0,1,1,0,1,0,0,1,1,0,1,1,0,0,0,0,0,0,1,0,1,1,1);
SC5 : array [0..63] of byte =
     (1,0,0,0,1,1,1,1,0,0,1,1,0,0,1,0,1,1,1,0,0,1,0,0,0,0,1,1,1,0,0,1,
      0,1,0,1,1,0,1,0,1,0,0,0,1,1,0,1,1,0,0,1,0,1,1,0,1,1,0,0,1,0,0,1);
SC6 : array [0..63] of byte =
     (0,0,1,1,0,1,1,0,0,0,1,0,1,1,0,1,1,1,0,1,1,0,0,0,1,0,0,1,0,1,1,0,
      0,1,1,0,1,0,0,1,1,0,0,1,0,0,1,1,0,1,1,0,0,0,1,1,1,1,0,1,1,0,0,0);
SC7 : array [0..63] of byte =
     (0,1,1,1,1,0,0,0,1,0,0,1,0,1,1,0,0,0,1,1,0,0,0,1,1,1,0,0,1,1,0,1,
      0,0,1,0,0,1,1,1,1,1,1,0,0,0,0,1,1,1,0,0,0,0,1,1,0,0,0,1,1,1,1,0);
SC8 : array [0..63] of byte =
     (0,1,0,0,1,1,1,0,1,0,1,1,0,0,0,1,0,1,0,0,1,1,1,0,0,0,1,1,0,1,0,1,
      1,1,0,0,0,0,1,1,0,1,1,0,1,1,0,0,1,0,1,1,0,1,0,0,1,0,0,0,1,0,1,1);
SD1 : array [0..63] of byte =
     (0,0,1,1,0,1,1,0,1,0,0,0,1,1,0,1,0,1,1,0,0,0,1,1,0,0,0,1,1,1,1,0,
      0,1,0,0,1,0,0,1,1,0,1,1,1,0,1,0,1,0,0,0,0,1,1,1,1,1,1,0,0,0,0,1);
SD2 : array [0..63] of byte =
     (1,1,0,0,0,1,1,0,1,1,0,1,0,0,1,0,1,1,0,1,1,0,0,0,0,0,1,0,0,1,1,1,
      0,0,1,1,0,0,1,1,1,0,0,0,1,1,0,1,1,0,0,1,1,1,0,0,1,0,1,0,0,1,0,1);
SD3 : array [0..63] of byte =
     (0,0,1,0,0,1,1,1,1,1,0,1,1,0,0,0,1,1,0,1,1,0,0,0,0,0,1,0,0,1,1,1,
      1,0,0,1,0,1,1,0,1,1,0,0,1,0,0,1,1,0,1,0,0,1,0,1,0,1,0,1,1,1,0,0);
SD4 : array [0..63] of byte =
     (1,1,0,1,0,0,1,0,1,0,0,1,1,0,0,1,1,0,1,1,0,1,0,1,0,1,0,0,1,0,0,1,
      0,0,1,0,0,1,1,1,1,1,1,0,1,0,0,0,1,1,0,0,0,1,1,0,1,0,1,1,0,1,0,0);
SD5 : array [0..63] of byte =
     (0,0,0,1,1,0,1,0,0,1,1,1,1,0,0,1,0,1,0,0,0,1,1,1,1,0,1,0,1,1,0,0,
      0,0,1,1,0,1,1,0,1,1,0,1,0,1,0,0,1,0,0,1,1,0,0,1,0,1,0,1,0,0,1,1);
SD6 : array [0..63] of byte =
     (0,1,0,1,1,0,0,0,0,1,1,0,0,1,1,1,0,1,0,0,1,0,1,1,0,1,1,0,0,1,1,0,
      1,0,1,1,0,0,0,1,1,0,0,0,1,1,1,0,0,1,0,0,1,1,1,0,1,0,1,1,0,0,0,1);
SD7 : array [0..63] of byte =
     (0,1,0,0,1,0,0,1,1,0,1,1,1,0,0,1,1,0,1,1,0,1,1,0,0,1,1,0,0,1,0,0,
      1,0,1,1,0,1,1,0,0,1,0,0,0,1,1,0,0,1,1,0,1,0,0,1,1,1,0,1,0,0,1,0);
SD8 : array [0..63] of byte =
     (1,0,0,0,0,1,1,1,0,1,1,0,1,0,0,1,1,1,1,0,0,1,1,0,0,1,0,1,0,0,1,0,
      1,1,0,1,1,0,0,0,0,0,0,1,1,1,1,0,0,1,0,1,0,0,0,1,1,0,1,0,1,1,0,1);

Sc : array [1..768] of byte =
(15,18,12,25, 2, 6, 4, 1,16, 7,22,11,24,20,13, 5,27, 9,17, 8,28,21,14, 3,
 42,53,32,38,48,56,31,41,52,46,34,49,45,50,40,29,35,54,47,43,51,37,30,33,
 16,19,13,26, 3, 7, 5, 2,17, 8,23,12,25,21,14, 6,28,10,18, 9, 1,22,15, 4,
 43,54,33,39,49,29,32,42,53,47,35,50,46,51,41,30,36,55,48,44,52,38,31,34,
 18,21,15,28, 5, 9, 7, 4,19,10,25,14,27,23,16, 8, 2,12,20,11, 3,24,17, 6,
 45,56,35,41,51,31,34,44,55,49,37,52,48,53,43,32,38,29,50,46,54,40,33,36,
 20,23,17, 2, 7,11, 9, 6,21,12,27,16, 1,25,18,10, 4,14,22,13, 5,26,19, 8,
 47,30,37,43,53,33,36,46,29,51,39,54,50,55,45,34,40,31,52,48,56,42,35,38,
 22,25,19, 4, 9,13,11, 8,23,14, 1,18, 3,27,20,12, 6,16,24,15, 7,28,21,10,
 49,32,39,45,55,35,38,48,31,53,41,56,52,29,47,36,42,33,54,50,30,44,37,40,
 24,27,21, 6,11,15,13,10,25,16, 3,20, 5, 1,22,14, 8,18,26,17, 9, 2,23,12,
 51,34,41,47,29,37,40,50,33,55,43,30,54,31,49,38,44,35,56,52,32,46,39,42,
 26, 1,23, 8,13,17,15,12,27,18, 5,22, 7, 3,24,16,10,20,28,19,11, 4,25,14,
 53,36,43,49,31,39,42,52,35,29,45,32,56,33,51,40,46,37,30,54,34,48,41,44,
 28, 3,25,10,15,19,17,14, 1,20, 7,24, 9, 5,26,18,12,22, 2,21,13, 6,27,16,
 55,38,45,51,33,41,44,54,37,31,47,34,30,35,53,42,48,39,32,56,36,50,43,46,
  1, 4,26,11,16,20,18,15, 2,21, 8,25,10, 6,27,19,13,23, 3,22,14, 7,28,17,
 56,39,46,52,34,42,45,55,38,32,48,35,31,36,54,43,49,40,33,29,37,51,44,47,
  3, 6,28,13,18,22,20,17, 4,23,10,27,12, 8, 1,21,15,25, 5,24,16, 9, 2,19,
 30,41,48,54,36,44,47,29,40,34,50,37,33,38,56,45,51,42,35,31,39,53,46,49,
  5, 8, 2,15,20,24,22,19, 6,25,12, 1,14,10, 3,23,17,27, 7,26,18,11, 4,21,
 32,43,50,56,38,46,49,31,42,36,52,39,35,40,30,47,53,44,37,33,41,55,48,51,
  7,10, 4,17,22,26,24,21, 8,27,14, 3,16,12, 5,25,19, 1, 9,28,20,13, 6,23,
 34,45,52,30,40,48,51,33,44,38,54,41,37,42,32,49,55,46,39,35,43,29,50,53,
  9,12, 6,19,24,28,26,23,10, 1,16, 5,18,14, 7,27,21, 3,11, 2,22,15, 8,25,
 36,47,54,32,42,50,53,35,46,40,56,43,39,44,34,51,29,48,41,37,45,31,52,55,
 11,14, 8,21,26, 2,28,25,12, 3,18, 7,20,16, 9, 1,23, 5,13, 4,24,17,10,27,
 38,49,56,34,44,52,55,37,48,42,30,45,41,46,36,53,31,50,43,39,47,33,54,29,
 13,16,10,23,28, 4, 2,27,14, 5,20, 9,22,18,11, 3,25, 7,15, 6,26,19,12, 1,
 40,51,30,36,46,54,29,39,50,44,32,47,43,48,38,55,33,52,45,41,49,35,56,31,
 14,17,11,24, 1, 5, 3,28,15, 6,21,10,23,19,12, 4,26, 8,16, 7,27,20,13, 2,
 41,52,31,37,47,55,30,40,51,45,33,48,44,49,39,56,34,53,46,42,50,36,29,32);

Sd : array [1..768] of byte =
(14,17,11,24, 1, 5, 3,28,15, 6,21,10,23,19,12, 4,26, 8,16, 7,27,20,13, 2,
 41,52,31,37,47,55,30,40,51,45,33,48,44,49,39,56,34,53,46,42,50,36,29,32,
 13,16,10,23,28, 4, 2,27,14, 5,20, 9,22,18,11, 3,25, 7,15, 6,26,19,12, 1,
 40,51,30,36,46,54,29,39,50,44,32,47,43,48,38,55,33,52,45,41,49,35,56,31,
 11,14, 8,21,26, 2,28,25,12, 3,18, 7,20,16, 9, 1,23, 5,13, 4,24,17,10,27,
 38,49,56,34,44,52,55,37,48,42,30,45,41,46,36,53,31,50,43,39,47,33,54,29,
  9,12, 6,19,24,28,26,23,10, 1,16, 5,18,14, 7,27,21, 3,11, 2,22,15, 8,25,
 36,47,54,32,42,50,53,35,46,40,56,43,39,44,34,51,29,48,41,37,45,31,52,55,
  7,10, 4,17,22,26,24,21, 8,27,14, 3,16,12, 5,25,19, 1, 9,28,20,13, 6,23,
 34,45,52,30,40,48,51,33,44,38,54,41,37,42,32,49,55,46,39,35,43,29,50,53,
  5, 8, 2,15,20,24,22,19, 6,25,12, 1,14,10, 3,23,17,27, 7,26,18,11, 4,21,
 32,43,50,56,38,46,49,31,42,36,52,39,35,40,30,47,53,44,37,33,41,55,48,51,
  3, 6,28,13,18,22,20,17, 4,23,10,27,12, 8, 1,21,15,25, 5,24,16, 9, 2,19,
 30,41,48,54,36,44,47,29,40,34,50,37,33,38,56,45,51,42,35,31,39,53,46,49,
  1, 4,26,11,16,20,18,15, 2,21, 8,25,10, 6,27,19,13,23, 3,22,14, 7,28,17,
 56,39,46,52,34,42,45,55,38,32,48,35,31,36,54,43,49,40,33,29,37,51,44,47,
 28, 3,25,10,15,19,17,14, 1,20, 7,24, 9, 5,26,18,12,22, 2,21,13, 6,27,16,
 55,38,45,51,33,41,44,54,37,31,47,34,30,35,53,42,48,39,32,56,36,50,43,46,
 26, 1,23, 8,13,17,15,12,27,18, 5,22, 7, 3,24,16,10,20,28,19,11, 4,25,14,
 53,36,43,49,31,39,42,52,35,29,45,32,56,33,51,40,46,37,30,54,34,48,41,44,
 24,27,21, 6,11,15,13,10,25,16, 3,20, 5, 1,22,14, 8,18,26,17, 9, 2,23,12,
 51,34,41,47,29,37,40,50,33,55,43,30,54,31,49,38,44,35,56,52,32,46,39,42,
 22,25,19, 4, 9,13,11, 8,23,14, 1,18, 3,27,20,12, 6,16,24,15, 7,28,21,10,
 49,32,39,45,55,35,38,48,31,53,41,56,52,29,47,36,42,33,54,50,30,44,37,40,
 20,23,17, 2, 7,11, 9, 6,21,12,27,16, 1,25,18,10, 4,14,22,13, 5,26,19, 8,
 47,30,37,43,53,33,36,46,29,51,39,54,50,55,45,34,40,31,52,48,56,42,35,38,
 18,21,15,28, 5, 9, 7, 4,19,10,25,14,27,23,16, 8, 2,12,20,11, 3,24,17, 6,
 45,56,35,41,51,31,34,44,55,49,37,52,48,53,43,32,38,29,50,46,54,40,33,36,
 16,19,13,26, 3, 7, 5, 2,17, 8,23,12,25,21,14, 6,28,10,18, 9, 1,22,15, 4,
 43,54,33,39,49,29,32,42,53,47,35,50,46,51,41,30,36,55,48,44,52,38,31,34,
 15,18,12,25, 2, 6, 4, 1,16, 7,22,11,24,20,13, 5,27, 9,17, 8,28,21,14, 3,
 42,53,32,38,48,56,31,41,52,46,34,49,45,50,40,29,35,54,47,43,51,37,30,33);

VAR
G: array [1..768] of byte;
L,R,M : array[1..32] of byte;
C : array [1..56] of byte;
ck: longword;

procedure DES_init (key: block; fcode: boolean); assembler;
asm
                mov     edi,[ebp+8]
                lea     esi,C
                mov     ecx,7
@1:             test    byte ptr [edi+ecx],128
                setnz   [esi]
                inc     esi
                dec     ecx
                jns     @1
                mov     ecx,7
@2:             test    byte ptr [edi+ecx],64
                setnz   [esi]
                inc     esi
                dec     ecx
                jns     @2
                mov     ecx,7
@3:             test    byte ptr [edi+ecx],32
                setnz   [esi]
                inc     esi
                dec     ecx
                jns     @3
                test    byte ptr [edi+7],16
                setnz   [esi]
                inc     esi
                test    byte ptr [edi+6],16
                setnz   [esi]
                inc     esi
                test    byte ptr [edi+5],16
                setnz   [esi]
                inc     esi
                test    byte ptr [edi+4],16
                setnz   [esi]
                inc     esi
                mov     ecx,7
@4:             test    byte ptr [edi+ecx],2
                setnz   [esi]
                inc     esi
                dec     ecx
                jns     @4
                mov     ecx,7
@5:             test    byte ptr [edi+ecx],4
                setnz   [esi]
                inc     esi
                dec     ecx
                jns     @5
                mov     ecx,7
@6:             test    byte ptr [edi+ecx],8
                setnz   [esi]
                inc     esi
                dec     ecx
                jns     @6
                test    byte ptr [edi+3],16
                setnz   [esi]
                inc     esi
                test    byte ptr [edi+2],16
                setnz   [esi]
                inc     esi
                test    byte ptr [edi+1],16
                setnz   [esi]
                inc     esi
                test    byte ptr [edi],16
                setnz   [esi]
                cmp     byte ptr [ebp+12],0
                jne     @7
                lea     edi,Sd
                jmp     @8
@7:             lea     edi,Sc
@8:             lea     esi,G
                lea     ebx,C
                dec     ebx
                mov     ecx,767
                xor     eax,eax
@9:             mov     al,[edi+ecx]
                mov     dl,[ebx+eax]
                mov     [esi+ecx],dl
                dec     ecx
                jns     @9
end;

procedure DES_code (inpb: block; var outb: block); assembler;
asm
                lea     edi,L
                lea     esi,R
                mov     ebx,[ebp+8]
                mov     ecx,7
@1:             mov     al,[ebx+ecx]
                test    al,64
                setnz   [edi]
                test    al,128
                setnz   [esi]
                inc     edi
                inc     esi
                dec     ecx
                jns     @1
                mov     ecx,7
@2:             mov     al,[ebx+ecx]
                test    al,16
                setnz   [edi]
                test    al,32
                setnz   [esi]
                inc     edi
                inc     esi
                dec     ecx
                jns     @2
                mov     ecx,7
@3:             mov     al,[ebx+ecx]
                test    al,4
                setnz   [edi]
                test    al,8
                setnz   [esi]
                inc     edi
                inc     esi
                dec     ecx
                jns     @3
                mov     ecx,7
@4:             mov     al,[ebx+ecx]
                test    al,2
                setnz   [esi]
                and     al,1
                mov     [edi],al
                inc     edi
                inc     esi
                dec     ecx
                jns     @4
                lea     esi,G
                lea     ecx,M
                xor     ebx,ebx
                mov     ck,16
@5:             lea     edi,R
                mov     al,[edi+31]
                xor     al,[esi]
                shl     al,5
                mov     bl,al
                mov     al,[edi]
                inc     esi
                xor     al,[esi]
                shl     al,3
                or      bl,al
                inc     edi
                inc     esi
                mov     al,[edi]
                xor     al,[esi]
                shl     al,2
                or      bl,al
                inc     edi
                inc     esi
                mov     al,[edi]
                xor     al,[esi]
                shl     al,1
                or      bl,al
                inc     edi
                inc     esi
                mov     al,[edi]
                xor     al,[esi]
                or      bl,al
                inc     edi
                inc     esi
                mov     al,[edi]
                xor     al,[esi]
                shl     al,4
                or      bl,al
                lea     eax,SA1
                mov     dl,[eax+ebx]
                mov     [ecx+8],dl
                lea     eax,SB1
                mov     dl,[eax+ebx]
                mov     [ecx+16],dl
                lea     eax,SC1
                mov     dl,[eax+ebx]
                mov     [ecx+22],dl
                lea     eax,SD1
                mov     dl,[eax+ebx]
                mov     [ecx+30],dl
                dec     edi
                inc     esi
                mov     al,[edi]
                xor     al,[esi]
                shl     al,5
                mov     bl,al
                inc     edi
                inc     esi
                mov     al,[edi]
                xor     al,[esi]
                shl     al,3
                or      bl,al
                inc     edi
                inc     esi
                mov     al,[edi]
                xor     al,[esi]
                shl     al,2
                or      bl,al
                inc     edi
                inc     esi
                mov     al,[edi]
                xor     al,[esi]
                shl     al,1
                or      bl,al
                inc     edi
                inc     esi
                mov     al,[edi]
                xor     al,[esi]
                or      bl,al
                inc     edi
                inc     esi
                mov     al,[edi]
                xor     al,[esi]
                shl     al,4
                or      bl,al
                lea     eax,SA2
                mov     dl,[eax+ebx]
                mov     [ecx+12],dl
                lea     eax,SB2
                mov     dl,[eax+ebx]
                mov     [ecx+27],dl
                lea     eax,SC2
                mov     dl,[eax+ebx]
                mov     [ecx+1],dl
                lea     eax,SD2
                mov     dl,[eax+ebx]
                mov     [ecx+17],dl
                dec     edi
                inc     esi
                mov     al,[edi]
                xor     al,[esi]
                shl     al,5
                mov     bl,al
                inc     edi
                inc     esi
                mov     al,[edi]
                xor     al,[esi]
                shl     al,3
                or      bl,al
                inc     edi
                inc     esi
                mov     al,[edi]
                xor     al,[esi]
                shl     al,2
                or      bl,al
                inc     edi
                inc     esi
                mov     al,[edi]
                xor     al,[esi]
                shl     al,1
                or      bl,al
                inc     edi
                inc     esi
                mov     al,[edi]
                xor     al,[esi]
                or      bl,al
                inc     edi
                inc     esi
                mov     al,[edi]
                xor     al,[esi]
                shl     al,4
                or      bl,al
                lea     eax,SA3
                mov     dl,[eax+ebx]
                mov     [ecx+23],dl
                lea     eax,SB3
                mov     dl,[eax+ebx]
                mov     [ecx+15],dl
                lea     eax,SC3
                mov     dl,[eax+ebx]
                mov     [ecx+29],dl
                lea     eax,SD3
                mov     dl,[eax+ebx]
                mov     [ecx+5],dl
                dec     edi
                inc     esi
                mov     al,[edi]
                xor     al,[esi]
                shl     al,5
                mov     bl,al
                inc     edi
                inc     esi
                mov     al,[edi]
                xor     al,[esi]
                shl     al,3
                or      bl,al
                inc     edi
                inc     esi
                mov     al,[edi]
                xor     al,[esi]
                shl     al,2
                or      bl,al
                inc     edi
                inc     esi
                mov     al,[edi]
                xor     al,[esi]
                shl     al,1
                or      bl,al
                inc     edi
                inc     esi
                mov     al,[edi]
                xor     al,[esi]
                or      bl,al
                inc     edi
                inc     esi
                mov     al,[edi]
                xor     al,[esi]
                shl     al,4
                or      bl,al
                lea     eax,SA4
                mov     dl,[eax+ebx]
                mov     [ecx+25],dl
                lea     eax,SB4
                mov     dl,[eax+ebx]
                mov     [ecx+19],dl
                lea     eax,SC4
                mov     dl,[eax+ebx]
                mov     [ecx+9],dl
                lea     eax,SD4
                mov     dl,[eax+ebx]
                mov     [ecx],dl
                dec     edi
                inc     esi
                mov     al,[edi]
                xor     al,[esi]
                shl     al,5
                mov     bl,al
                inc     edi
                inc     esi
                mov     al,[edi]
                xor     al,[esi]
                shl     al,3
                or      bl,al
                inc     edi
                inc     esi
                mov     al,[edi]
                xor     al,[esi]
                shl     al,2
                or      bl,al
                inc     edi
                inc     esi
                mov     al,[edi]
                xor     al,[esi]
                shl     al,1
                or      bl,al
                inc     edi
                inc     esi
                mov     al,[edi]
                xor     al,[esi]
                or      bl,al
                inc     edi
                inc     esi
                mov     al,[edi]
                xor     al,[esi]
                shl     al,4
                or      bl,al
                lea     eax,SA5
                mov     dl,[eax+ebx]
                mov     [ecx+7],dl
                lea     eax,SB5
                mov     dl,[eax+ebx]
                mov     [ecx+13],dl
                lea     eax,SC5
                mov     dl,[eax+ebx]
                mov     [ecx+24],dl
                lea     eax,SD5
                mov     dl,[eax+ebx]
                mov     [ecx+2],dl
                dec     edi
                inc     esi
                mov     al,[edi]
                xor     al,[esi]
                shl     al,5
                mov     bl,al
                inc     edi
                inc     esi
                mov     al,[edi]
                xor     al,[esi]
                shl     al,3
                or      bl,al
                inc     edi
                inc     esi
                mov     al,[edi]
                xor     al,[esi]
                shl     al,2
                or      bl,al
                inc     edi
                inc     esi
                mov     al,[edi]
                xor     al,[esi]
                shl     al,1
                or      bl,al
                inc     edi
                inc     esi
                mov     al,[edi]
                xor     al,[esi]
                or      bl,al
                inc     edi
                inc     esi
                mov     al,[edi]
                xor     al,[esi]
                shl     al,4
                or      bl,al
                lea     eax,SA6
                mov     dl,[eax+ebx]
                mov     [ecx+3],dl
                lea     eax,SB6
                mov     dl,[eax+ebx]
                mov     [ecx+28],dl
                lea     eax,SC6
                mov     dl,[eax+ebx]
                mov     [ecx+10],dl
                lea     eax,SD6
                mov     dl,[eax+ebx]
                mov     [ecx+18],dl
                dec     edi
                inc     esi
                mov     al,[edi]
                xor     al,[esi]
                shl     al,5
                mov     bl,al
                inc     edi
                inc     esi
                mov     al,[edi]
                xor     al,[esi]
                shl     al,3
                or      bl,al
                inc     edi
                inc     esi
                mov     al,[edi]
                xor     al,[esi]
                shl     al,2
                or      bl,al
                inc     edi
                inc     esi
                mov     al,[edi]
                xor     al,[esi]
                shl     al,1
                or      bl,al
                inc     edi
                inc     esi
                mov     al,[edi]
                xor     al,[esi]
                or      bl,al
                inc     edi
                inc     esi
                mov     al,[edi]
                xor     al,[esi]
                shl     al,4
                or      bl,al
                lea     eax,SA7
                mov     dl,[eax+ebx]
                mov     [ecx+31],dl
                lea     eax,SB7
                mov     dl,[eax+ebx]
                mov     [ecx+11],dl
                lea     eax,SC7
                mov     dl,[eax+ebx]
                mov     [ecx+21],dl
                lea     eax,SD7
                mov     dl,[eax+ebx]
                mov     [ecx+6],dl
                dec     edi
                inc     esi
                mov     al,[edi]
                xor     al,[esi]
                shl     al,5
                mov     bl,al
                inc     edi
                inc     esi
                mov     al,[edi]
                xor     al,[esi]
                shl     al,3
                or      bl,al
                inc     edi
                inc     esi
                mov     al,[edi]
                xor     al,[esi]
                shl     al,2
                or      bl,al
                inc     edi
                inc     esi
                mov     al,[edi]
                xor     al,[esi]
                shl     al,1
                or      bl,al
                inc     edi
                inc     esi
                mov     al,[edi]
                xor     al,[esi]
                or      bl,al
                lea     edi,R
                inc     esi
                mov     al,[edi]
                xor     al,[esi]
                shl     al,4
                or      bl,al
                lea     eax,SA8
                mov     dl,[eax+ebx]
                mov     [ecx+4],dl
                lea     eax,SB8
                mov     dl,[eax+ebx]
                mov     [ecx+26],dl
                lea     eax,SC8
                mov     dl,[eax+ebx]
                mov     [ecx+14],dl
                lea     eax,SD8
                mov     dl,[eax+ebx]
                mov     [ecx+20],dl
                push    esi
                lea     edi,L
                lea     esi,R
                mov     ebx,7
@6:             mov     eax,[edi+ebx*4]
                mov     edx,[esi+ebx*4]
                xor     eax,[ecx+ebx*4]
                mov     [esi+ebx*4],eax
                mov     [edi+ebx*4],edx
                dec     ebx
                jnz     @6
                mov     eax,[edi]
                mov     edx,[esi]
                xor     eax,[ecx]
                mov     [esi],eax
                mov     [edi],edx
                pop     esi
                inc     esi
                dec     ck
                jnz     @5
                lea     edi,L
                lea     esi,R
                mov     ecx,[ebp+12]
                mov     al,[edi+7]
                shl     al,7
                mov     bl,[esi+7]
                shl     bl,6
                or      al,bl
                mov     bl,[edi+15]
                shl     bl,5
                or      al,bl
                mov     bl,[esi+15]
                shl     bl,4
                or      al,bl
                mov     bl,[edi+23]
                shl     bl,3
                or      al,bl
                mov     bl,[esi+23]
                shl     bl,2
                or      al,bl
                mov     bl,[edi+31]
                shl     bl,1
                or      al,bl
                or      al,[esi+31]
                mov     [ecx],al
                mov     al,[edi+6]
                shl     al,7
                mov     bl,[esi+6]
                shl     bl,6
                or      al,bl
                mov     bl,[edi+14]
                shl     bl,5
                or      al,bl
                mov     bl,[esi+14]
                shl     bl,4
                or      al,bl
                mov     bl,[edi+22]
                shl     bl,3
                or      al,bl
                mov     bl,[esi+22]
                shl     bl,2
                or      al,bl
                mov     bl,[edi+30]
                shl     bl,1
                or      al,bl
                or      al,[esi+30]
                mov     [ecx+1],al
                mov     al,[edi+5]
                shl     al,7
                mov     bl,[esi+5]
                shl     bl,6
                or      al,bl
                mov     bl,[edi+13]
                shl     bl,5
                or      al,bl
                mov     bl,[esi+13]
                shl     bl,4
                or      al,bl
                mov     bl,[edi+21]
                shl     bl,3
                or      al,bl
                mov     bl,[esi+21]
                shl     bl,2
                or      al,bl
                mov     bl,[edi+29]
                shl     bl,1
                or      al,bl
                or      al,[esi+29]
                mov     [ecx+2],al
                mov     al,[edi+4]
                shl     al,7
                mov     bl,[esi+4]
                shl     bl,6
                or      al,bl
                mov     bl,[edi+12]
                shl     bl,5
                or      al,bl
                mov     bl,[esi+12]
                shl     bl,4
                or      al,bl
                mov     bl,[edi+20]
                shl     bl,3
                or      al,bl
                mov     bl,[esi+20]
                shl     bl,2
                or      al,bl
                mov     bl,[edi+28]
                shl     bl,1
                or      al,bl
                or      al,[esi+28]
                mov     [ecx+3],al
                mov     al,[edi+3]
                shl     al,7
                mov     bl,[esi+3]
                shl     bl,6
                or      al,bl
                mov     bl,[edi+11]
                shl     bl,5
                or      al,bl
                mov     bl,[esi+11]
                shl     bl,4
                or      al,bl
                mov     bl,[edi+19]
                shl     bl,3
                or      al,bl
                mov     bl,[esi+19]
                shl     bl,2
                or      al,bl
                mov     bl,[edi+27]
                shl     bl,1
                or      al,bl
                or      al,[esi+27]
                mov     [ecx+4],al
                mov     al,[edi+2]
                shl     al,7
                mov     bl,[esi+2]
                shl     bl,6
                or      al,bl
                mov     bl,[edi+10]
                shl     bl,5
                or      al,bl
                mov     bl,[esi+10]
                shl     bl,4
                or      al,bl
                mov     bl,[edi+18]
                shl     bl,3
                or      al,bl
                mov     bl,[esi+18]
                shl     bl,2
                or      al,bl
                mov     bl,[edi+26]
                shl     bl,1
                or      al,bl
                or      al,[esi+26]
                mov     [ecx+5],al
                mov     al,[edi+1]
                shl     al,7
                mov     bl,[esi+1]
                shl     bl,6
                or      al,bl
                mov     bl,[edi+9]
                shl     bl,5
                or      al,bl
                mov     bl,[esi+9]
                shl     bl,4
                or      al,bl
                mov     bl,[edi+17]
                shl     bl,3
                or      al,bl
                mov     bl,[esi+17]
                shl     bl,2
                or      al,bl
                mov     bl,[edi+25]
                shl     bl,1
                or      al,bl
                or      al,[esi+25]
                mov     [ecx+6],al
                mov     al,[edi]
                shl     al,7
                mov     bl,[esi]
                shl     bl,6
                or      al,bl
                mov     bl,[edi+8]
                shl     bl,5
                or      al,bl
                mov     bl,[esi+8]
                shl     bl,4
                or      al,bl
                mov     bl,[edi+16]
                shl     bl,3
                or      al,bl
                mov     bl,[esi+16]
                shl     bl,2
                or      al,bl
                mov     bl,[edi+24]
                shl     bl,1
                or      al,bl
                or      al,[esi+24]
                mov     [ecx+7],al
end;

END.
